/*
  ΥѴ (Unnormalized DCT-II):
      F[k]=_j=0^n-1 a[j]*cos(pi*(j+1/2)*k/n),0<=k<n 
  ׻.
  * ˡ
      B.G.Lee ˤʬ: 
      Cooley-Tukey  FFT: 
       2, ȿְ, Хե饤 1, in-place ¤ؤ
  * 
      n ϥǡ 2 .
*/
#include <math.h>

void fct_ii(int n, double a[])
{
    int m, mh, i, j, k, irev, j0, j1;
    double theta, c2, xr;

    /* ---- scrambler ---- */
    i = 0;
    for (j = 1; j < n - 1; j++) {
        for (k = n >> 1; k > (i ^= k); k >>= 1);
        if (j < i) {
            xr = a[j];
            a[j] = a[i];
            a[i] = xr;
        }
    }
    theta = 2 * atan(1.0) / n;
    /* ---- butterflies ---- */
    for (mh = 1; (m = mh << 1) <= n; mh = m) {
        irev = 0;
        for (i = 0; i < n; i += m) {
            c2 = 2 * cos(theta * (irev + mh));
            for (k = n >> 1; k > (irev ^= k); k >>= 1);
            for (j = 0; j < mh; j++) {
                j0 = i + j;
                j1 = n - mh - i + j;
                xr = a[j0] - a[j1];
                a[j0] += a[j1];
                a[j1] = c2 * xr;
            }
        }
    }
    /* ---- adds ---- */
    for (m = n >> 1; (mh = m >> 1) >= 1; m = mh) {
        for (j = 0; j < mh; j++) {
            j0 = m + mh + j;
            a[j0] = -a[j0] - a[j0 - m];
        }
        for (i = (m << 1) + mh; i < n; i += (m << 1)) {
            for (j = 0; j < mh; j++) {
                j0 = i + j;
                j1 = j0 + m;
                a[j0] -= a[j0 - m];
                a[j1] = -a[j1] - a[j0];
            }
        }
    }
    /* ---- scaling ---- */
    for (j = 1; j < n; j++) {
        a[j] *= 0.5;
    }
}

